
/* LIBRAIRIE DE GESTION DU GLCD */

/************************ INCLUDE *****************************/
#include <p18cxxx.h>	       /* C18 compiler processor defs */
#include "h/GLCD.h"

/****************** DECLARATION DES VARIABLES *****************/
const far rom unsigned char Font[96][7];
const far rom unsigned char Font2[95][5];
const far rom unsigned char FontSmall[10][7];
const far rom unsigned char Font18[12][16];

unsigned char i;
unsigned char XPos,YPos;
unsigned far rom char dat;

/**************** DECLARATION DES SOUS PROGRAMMES *************/

/*************************************************************
**************  FONCTION D'ATTENTE POUR LE GLCD  *************
*************************************************************/
void Delay(void){
char x;
for(x=0;x<2;x++)
_asm        NOP        _endasm
}


// ..............................
// Config for CS pins          //
// ..............................
//#define CS_pins_active_high  // CS pins are NOT complemented        
#define CS_pins_active_low     // CS pins are complemented
// ..............................

#ifdef  CS_pins_active_high
#define ENABLED 1
#define DISABLED 0
#endif

#ifdef  CS_pins_active_low 
#define ENABLED 0
#define DISABLED 1
#endif

/*************************************************************/

unsigned char GLCD_Read(void){
        b_GLCD_E=1;
        Delay();
        dat=GLCD_Data;
        b_GLCD_E=0;
        Delay();
        return dat;
}


void Wait_Not_Busy(void){

        TRIS_Data=0xff;

        b_GLCD_RS=0;
        b_GLCD_RW=1;
        
        if (b_GLCD_GCS1 == ENABLED && b_GLCD_GCS2== ENABLED)
                {
                b_GLCD_GCS1 = DISABLED;
                while (GLCD_Read()&0x80);
                b_GLCD_GCS1 = ENABLED;
                b_GLCD_GCS2= DISABLED;
                while (GLCD_Read()&0x80);
                b_GLCD_GCS2= ENABLED;
                }
        else{
                while (GLCD_Read()&0x80);
        }
        TRIS_Data=0x00;
}


void GLCD_Write_Cmd(unsigned char data){
        Wait_Not_Busy();
        GLCD_Data = data;
        b_GLCD_RS=0;
        b_GLCD_RW=0;
        b_GLCD_E=1;
        Delay();
        b_GLCD_E=0;
}


void GLCD_Write_Data (unsigned char data){
        Wait_Not_Busy();
//		GLCD_Data = data^0xff;	// inverse display mode
        GLCD_Data = data;		// regular display mode
        b_GLCD_RS=1;
        b_GLCD_RW=0;
        b_GLCD_E=1;
        Delay();
        b_GLCD_E=0;
}

unsigned char GLCD_Read_Data(void){
	Wait_Not_Busy();
	TRIS_Data=0xff;
	b_GLCD_RS=1;
	b_GLCD_RW=1;
	b_GLCD_E=1;
	Delay();
//	dat=GLCD_Data^0xff;			// inverse display mode
	dat=GLCD_Data;				// regular display mode
	b_GLCD_E=0;
	TRIS_Data=0x00;
	return dat;
}




void MoveRight(void){
        if(++XPos==64){
                WritePosition();
        }
        if(XPos==128){
                XPos=0;
                YPos+=8;
                YPos=YPos&0x3f;
                WritePosition();
        }
}

void MoveRightH(void){
                XPos+=1;
                YPos-=8;
                YPos=YPos&0x3f;
                WritePosition();
}

void MoveDown(void){
                XPos-=8;
                YPos+=8;
                YPos=YPos&0x3f;
                WritePosition();
}

void WritePosition(void){
        if(XPos>63){
                b_GLCD_GCS1= DISABLED;
                b_GLCD_GCS2= ENABLED;
        }
        else{
                b_GLCD_GCS1= ENABLED;
                b_GLCD_GCS2= DISABLED;
        }
        GLCD_Write_Cmd(0x40+(XPos&0x3f));                //column=0
        GLCD_Write_Cmd(0xb8+((YPos&0x3f)>>3));        //row=0
}


/*************************************************************
************  POSITIONNEMENT DU CURSEUR  *********************
*************************************************************/
void SetPos(unsigned char x,unsigned char y){
        XPos=x;
        YPos=y;
        WritePosition();
}

/*************************************************************
*********  ALLUMAGE EXTINCTION D'UN POINT  *******************
*************************************************************/


void plot(unsigned char x,unsigned char y){
unsigned char d;

    if(x>127 || y>63)
        return;
        
        if(x>63){
                b_GLCD_GCS1= DISABLED;
                b_GLCD_GCS2= ENABLED;
                x-=64;
        }
        else
        {
                b_GLCD_GCS1= ENABLED;
                b_GLCD_GCS2= DISABLED;
        }
        GLCD_Write_Cmd(0x40+x);                                                // write column address
        GLCD_Write_Cmd(0xb8+(y>>3));                                // write row address
        d=GLCD_Read_Data();                                                        // dummy read
        d=GLCD_Read_Data();
        GLCD_Write_Cmd(0x40+x);                                                // write column address again
        d=d|(1<<(y&7));                                                        // avant
//      d=d&(0xff-(1<<(y&7)));
        GLCD_Write_Data(d);
       GLCD_Write_Cmd(0x3f);                                            // ajoute : display on
}




void unplot(unsigned char x,unsigned char y){
unsigned char d;

	    if(x>127 || y>63)
        return;

        if(x>63){
                b_GLCD_GCS1= DISABLED;
                b_GLCD_GCS2= ENABLED;
                x-=64;
        }
        else
        {
                b_GLCD_GCS1= ENABLED;
                b_GLCD_GCS2= DISABLED;
        }
        GLCD_Write_Cmd(0x40+x);                     // write column address
        GLCD_Write_Cmd(0xb8+(y>>3));        		// write row address
        d=GLCD_Read_Data();                         // dummy read
        d=GLCD_Read_Data();
        GLCD_Write_Cmd(0x40+x);                     // write column address again

        // Type d'affichage :
        //d = d & (0xff - (1 << (y & 7)));          // Ecriture  l'interrieur du Rtro clairage
        d=d|(1<<(y&7));                             // Noir sur Blanc

        GLCD_Write_Data(d);
}




/*************************************************************
*********************  AFFICHAGE MESSAGE  ********************
*************************************************************/

void PutMessage( char rom *Message){
        while(*Message!=0)         // Tant qu'on est pas a la fin de chaine de caracteres, on va chercher le contenu de la memoire dont l'adresse est indique par le pointeur.
                if(*Message==0x16){
                        *Message++;
                        XPos=*Message++;
                        YPos=*Message++;
                        WritePosition();
                }
                else
                        PutChar(*Message++);
}


/*************************************************************
************************  FONCTION GRAPHIQUE  ****************
*************************************************************/
//  ( dbut ligne X, fin de ligne X, cartement depuis le haut de l'ecran )
void hline(unsigned char x1,unsigned char x2,unsigned char y){
unsigned char i = 0;

        for(i=x1;i<x2;i++)
                plot(i,y);
}


//  ( cartement depuis bord gauche, debut ligne Y , fin ligne Y )
void vline(unsigned char x,unsigned char y1,unsigned char y2){
unsigned char i = 0;

        for(i=y1;i<y2;i++)
                plot(x,i);
}


void box(unsigned char x1,unsigned char y1,
        unsigned char x2,unsigned char y2){
        hline(x1,x2,y1);
        hline(x1,x2,y2);
        vline(x1,y1,y2);
        vline(x2,y1,y2);
        plot(x2,y2);
}



void FilledBox(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2){
unsigned char i;
    for(i=y1;i<y2;i++){
        vline(x1,x2,i);
    }
}


void circle(int xc,int yc,int r)
{
        int x=0,y=r,dp;
        dp=1-r;
        for(;x<y;x++)
        {
                if(dp<0)
                {
                        dp+=2*x+3;
                }
                else
                {
                        dp+=2*(x-y)+5;
                        y--;
                }
                plot(x+xc,y+yc);
                plot(-x+xc,-y+yc);
            plot(x+xc,-y+yc);
                plot(-x+xc,y+yc);
                plot(y+xc,x+yc);
                plot(-y+xc,-x+yc);
                plot(-y+xc,x+yc);
                plot(y+xc,-x+yc);
        }
}


/*************************************************************
*************  EFFACEMENT ET REMPLISSAGE ZONE-ECRAN  ********
*************************************************************/

void ClearScreen(void){
unsigned char i,j;
        b_GLCD_GCS1= ENABLED;
        b_GLCD_GCS2= ENABLED;
        for(i=0;i<8;i++){
                GLCD_Write_Cmd(0x40);        //y=0
                GLCD_Write_Cmd(0xb8+i);        //x=0
                for(j=0;j<0x40;j++)
                        GLCD_Write_Data(0x00);        //0x00 -> pour blanc et 0xff pour noir
        }
        SetPos(0,0);
}

void FillWhiteZone(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2){
char i,j;
    for(i=x1;i<=x2;i++){
        for(j=y1;j<=y2;j++)
            unplot(i,j);
    }
}

void FillBlackZone(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2){
char i,j;
    for(i=x1;i<=x2;i++){
        for(j=y1;j<=y2;j++)
            plot(i,j);
    }
}


/*************************************************************
******************  INITIALISATION LCD  **********************
*************************************************************/

void Init_GLCD(void){
unsigned char i;

    b_TRIS_GCS1=0;
    b_TRIS_GCS2=0;
    b_TRIS_RS=0;
    b_TRIS_RW=0;
    b_TRIS_E=0;
//  b_TRIS_On=0;        // Reset Pin not available on my GLCD
    b_TRIS_BL=0;

//  b_GLCD_On=1;
        b_GLCD_GCS1= ENABLED;
        b_GLCD_GCS2= ENABLED;
    b_GLCD_BL=1;


        GLCD_Write_Cmd(0x3f);        //display on
        GLCD_Write_Cmd(0xc0);        //z=0
        ClearScreen();

}

/*************************************************************
**********************  AFFICHAGE LOGO  **********************
*************************************************************/

void PutLogo(char far rom *logo){
unsigned char larg,haut,bitcount,Byte;
         larg=*logo++;
        haut=*logo++;
        bitcount=0;
        do{
                for(i=0;i<larg;i++){
                        if(bitcount==0){
                                bitcount=8;
                                Byte=*logo++;
                        }
                        if(Byte&1) plot(XPos,YPos);
                        XPos++;
                        Byte/=2;
                        bitcount--;
                }
                YPos++;
                XPos-=larg;
        }while(--haut);
}

/*************************************************************
***************  AFFICHAGE PETIT CARACTERE  ******************
*************************************************************/

void PutSmallChar(unsigned char data){
unsigned char i,d;
        if(data<32){
                switch(data){
                        case 13:
                                XPos=0;
                        case 10:
                                XPos=0;
                                YPos+=8;
                                YPos=YPos&63;
                }
                WritePosition();
        }
        else{
                for(i=0;i<7;i++){
                        d=FontSmall[data-48][i];
                        if(d!=0x55){
                                //d=~d;                                //ADD pour Noir sur Blanc
                                GLCD_Write_Data(d);
                                MoveRight();
                        }
                }
                GLCD_Write_Data(0x00);                        //Noir sur Blanc
                //GLCD_Write_Data(0xff);                //Blanc sur Noir
                MoveRight();
        }
}


void displaySmallNum(int x, int y, short int INTValue) {
    char toPrint[4];
    
        if((INTValue >= 0)&&(INTValue < 10))
                {
                toPrint[0] =(INTValue%10)+48;
            SetPos(x,y);
            PutSmallChar(toPrint[0]);
                }

        if((INTValue >= 10)&&(INTValue < 100))
                {
                toPrint[0] = (INTValue/10)+48;
                toPrint[1] = (INTValue%10)+48;
            SetPos(x,y);
            PutSmallChar(toPrint[0]);
                PutSmallChar(toPrint[1]);                
                }

        if((INTValue >= 100)&&(INTValue < 1000))
                {
                toPrint[0] = ((INTValue/100)%10)+48;
                toPrint[1] = ((INTValue/10)%10)+48;
                toPrint[2] = (INTValue%10)+48;
            SetPos(x,y);
            PutSmallChar(toPrint[0]);
                PutSmallChar(toPrint[1]);        
                PutSmallChar(toPrint[2]);        
                }

        if((INTValue >= 1000)&&(INTValue < 10000))
                {
                toPrint[0] = ((INTValue/1000)%10)+48;
                toPrint[1] = ((INTValue/100)%10)+48;
                toPrint[2] = ((INTValue/10)%10)+48;
                toPrint[3] = (INTValue%10)+48;
            SetPos(x,y);
            PutSmallChar(toPrint[0]);
                PutSmallChar(toPrint[1]);        
                PutSmallChar(toPrint[2]);        
                PutSmallChar(toPrint[3]);
                }
}

/*************************************************************
***************  AFFICHAGE CARACTERE NORMAL  *****************
*************************************************************/

void PutChar(unsigned char data){
unsigned char i,d;
        if(data<32){
                switch(data){
                        case 13:
                                XPos=0;
                        case 10:
                                XPos=0;
                                YPos+=8;
                                YPos=YPos&63;
                }
                WritePosition();
        }
        else{
                for(i=0;i<7;i++){
                        d=Font[data-32][i];
                        if(d!=0x55){
                                d=~d;                                //ADD pour Noir sur Blanc
                                GLCD_Write_Data(d);
                                MoveRight();
                        }
                }
                GLCD_Write_Data(0x00);                //Noir sur Blanc
                //GLCD_Write_Data(0xff);                //Blanc sur Noir
                MoveRight();
        }
}


void PutFloat(char* floatdata){
    i=0;
    while(floatdata[i]!=0)
            PutChar(floatdata[i++]);
}



void displayNum(int x, int y, short int INTValue) {
    char toPrint[4];
    
        if((INTValue >= 0)&&(INTValue < 10))
                {
                toPrint[0] =(INTValue%10)+48;
            SetPos(x,y);
            PutChar(toPrint[0]);
                }

        if((INTValue >= 10)&&(INTValue < 100))
                {
                toPrint[0] = (INTValue/10)+48;
                toPrint[1] = (INTValue%10)+48;
            SetPos(x,y);
            PutChar(toPrint[0]);
                PutChar(toPrint[1]);                
                }

        if((INTValue >= 100)&&(INTValue < 1000))
                {
                toPrint[0] = ((INTValue/100)%10)+48;
                toPrint[1] = ((INTValue/10)%10)+48;
                toPrint[2] = (INTValue%10)+48;
            SetPos(x,y);
            PutChar(toPrint[0]);
                PutChar(toPrint[1]);        
                PutChar(toPrint[2]);        
                }

        if((INTValue >= 1000)&&(INTValue < 10000))
                {
                toPrint[0] = ((INTValue/1000)%10)+48;
                toPrint[1] = ((INTValue/100)%10)+48;
                toPrint[2] = ((INTValue/10)%10)+48;
                toPrint[3] = (INTValue%10)+48;
            SetPos(x,y);
            PutChar(toPrint[0]);
                PutChar(toPrint[1]);        
                PutChar(toPrint[2]);        
                PutChar(toPrint[3]);
                }
}


/*************************************************************
***************  AFFICHAGE GROS CARACTERE  *******************
*************************************************************/

void PutHChar(unsigned char data){
unsigned char i,d;
        if(data<32){
                switch(data){
                        case 13:
                                XPos=0;
                        case 10:
                                XPos=0;
                                YPos+=8;
                                YPos=YPos&63;
                }
                WritePosition();
        }
        else{
                for(i=0;i<8;i++){
                        d=Font18[data-46][i];
                        if(d!=0x55){
                                GLCD_Write_Data(d);
                                MoveRight();
                        }
                }
                MoveDown ();
                for(i=8;i<16;i++){
                        d=Font18[data-46][i];
                        if(d!=0x55){
                                GLCD_Write_Data(d);
                                MoveRight();
                        }
                }
                GLCD_Write_Data(0x00);                //Noir sur Blanc
                MoveRightH();
        }
}


void PutHFloat(char* floatdata){
    i=0;
    while(floatdata[i]!=0)
            PutHChar(floatdata[i++]);
}

void displayHNum(int x, int y, short int INTValue) {
    char toPrint[4];
    
        if((INTValue >= 0)&&(INTValue < 10))
                {
                toPrint[0] =(INTValue%10)+48;
            SetPos(x,y);
            PutHChar(toPrint[0]);
                }

        if((INTValue >= 10)&&(INTValue < 100))
                {
                toPrint[0] = (INTValue/10)+48;
                toPrint[1] = (INTValue%10)+48;
            SetPos(x,y);
            PutHChar(toPrint[0]);
                PutHChar(toPrint[1]);                
                }

        if((INTValue >= 100)&&(INTValue < 1000))
                {
                toPrint[0] = ((INTValue/100)%10)+48;
                toPrint[1] = ((INTValue/10)%10)+48;
                toPrint[2] = (INTValue%10)+48;
            SetPos(x,y);
            PutHChar(toPrint[0]);
                PutHChar(toPrint[1]);        
                PutHChar(toPrint[2]);        
                }

        if((INTValue >= 1000)&&(INTValue < 10000))
                {
                toPrint[0] = ((INTValue/1000)%10)+48;
                toPrint[1] = ((INTValue/100)%10)+48;
                toPrint[2] = ((INTValue/10)%10)+48;
                toPrint[3] = (INTValue%10)+48;
            SetPos(x,y);
            PutHChar(toPrint[0]);
                PutHChar(toPrint[1]);        
                PutHChar(toPrint[2]);        
                PutHChar(toPrint[3]);
                }
}



// It puts the display at x,y with percent/10 bars.
void PutBars(unsigned char x,unsigned char y,unsigned char Percent){
unsigned char i,j;
        for(i=0;i<10;i++){
            if(i<(100-Percent)/10){
                for(j=x+i;j<x+11;j++)
                    unplot(j,y+2*i);
            }else
                vline(x+i,x+10,y+2*i);
        }            
}



/****************** DECLARATION DES SYMBOLES ******************/
const far rom unsigned char FontSmall[10][7]={
        0x3E,0x41,0x41,0x3E,0x55,0x55,0x55,        //        48        0
        0x42,0x7F,0x40,0x55,0x55,0x55,0x55,        //        49        1
        0x62,0x51,0x49,0x46,0x55,0x55,0x55,        //        50        2
        0x22,0x49,0x49,0x36,0x55,0x55,0x55,        //        51        3
        0x18,0x14,0x12,0x7F,0x55,0x55,0x55,        //        52        4
        0x27,0x49,0x49,0x31,0x55,0x55,0x55,        //        53        5
        0x3C,0x4A,0x49,0x31,0x55,0x55,0x55,        //        54        6
        0x71,0x09,0x05,0x03,0x55,0x55,0x55,        //        55        7
        0x36,0x49,0x49,0x36,0x55,0x55,0x55,        //        56        8
        0x46,0x49,0x29,0x1E,0x55,0x55,0x55,        //        57        9

};


const far rom unsigned char Font[96][7]={
        0xFF,0xFF,0xFF,0x55,0x55,0x55,0x55,        //        32         
        0xFF,0xA0,0xFF,0x55,0x55,0x55,0x55,        //        33        !
        0xF8,0xFF,0xF8,0x55,0x55,0x55,0x55,        //        34        ""
        0xEB,0x80,0xEB,0x80,0xEB,0x55,0x55,        //        35        #
        0xD9,0xB6,0x80,0xB6,0xCD,0x55,0x55,        //        36        $
        0x9C,0xEC,0xF7,0x9B,0x9C,0x55,0x55,        //        37        %
        0xC9,0xB6,0xFF,0xDD,0xAF,0x55,0x55,        //        38        &
        0xFB,0xFC,0xFF,0x55,0x55,0x55,0x55,        //        39        '
        0xE3,0xDD,0xBE,0x55,0x55,0x55,0x55,        //        40        (
        0xBE,0xDD,0xE3,0x55,0x55,0x55,0x55,        //        41        )
        0xEB,0xD5,0xE3,0xD5,0xEB,0x55,0x55,        //        42        *
        0xF7,0xF7,0xC1,0xF7,0xF7,0x55,0x55,        //        43        +
        0x7F,0x9F,0x55,0x55,0x55,0x55,0x55,        //        44        ,
        0xF7,0xF7,0xF7,0xF7,0xF7,0x55,0x55,        //        45        -
        0xBF,0x55,0x55,0x55,0x55,0x55,0x55,        //        46        .
        0x9F,0xEF,0xF7,0xFB,0xFC,0x55,0x55,        //        47        /
        0xC1,0xAE,0xB6,0xBA,0xC1,0x55,0x55,        //        48        0
        0xFF,0xBD,0x80,0xBF,0xFF,0x55,0x55,        //        49        1
        0x9D,0xAE,0xB6,0xB6,0xB9,0x55,0x55,        //        50        2
        0xDD,0xBE,0xB6,0xB6,0xC9,0x55,0x55,        //        51        3
        0xE7,0xEB,0xED,0x80,0xEF,0x55,0x55,        //        52        4
        0xD8,0xB6,0xB6,0xB6,0xCE,0x55,0x55,        //        53        5
        0xC3,0xB5,0xB6,0xB6,0xCF,0x55,0x55,        //        54        6
        0xFE,0x8E,0xF6,0xFA,0xFC,0x55,0x55,        //        55        7
        0xC9,0xB6,0xB6,0xB6,0xC9,0x55,0x55,        //        56        8
        0xF9,0xB6,0xB6,0xD6,0xE1,0x55,0x55,        //        57        9
        0xEB,0x55,0x55,0x55,0x55,0x55,0x55,        //        58        :
        0x7F,0x97,0x55,0x55,0x55,0x55,0x55,        //        59        ;
        0xF7,0xEB,0xDD,0xBE,0x55,0x55,0x55,        //        60        <
        0xEB,0xEB,0xEB,0xEB,0x55,0x55,0x55,        //        61        =
        0xBE,0xDD,0xEB,0xF7,0x55,0x55,0x55,        //        62        >
        0xFD,0xFE,0xAE,0xF6,0xF9,0x55,0x55,        //        63        ?
        0xC1,0xBE,0xA2,0xFF,0xB1,0x55,0x55,        //        64        @
        0x83,0xED,0xEE,0xED,0x83,0x55,0x55,        //        65        A
        0x80,0xB6,0xB6,0xB6,0xC9,0x55,0x55,        //        66        B
        0xC1,0xBE,0xBE,0xBE,0xDD,0x55,0x55,        //        67        C
        0x80,0xBE,0xBE,0xDD,0xE3,0x55,0x55,        //        68        D
        0x80,0xB6,0xB6,0xB6,0xBE,0x55,0x55,        //        69        E
        0x80,0xF6,0xF6,0xF6,0xFE,0x55,0x55,        //        70        F
        0xC1,0xBE,0xB6,0xD6,0x8D,0x55,0x55,        //        71        G
        0x80,0xF7,0xF7,0xF7,0x80,0x55,0x55,        //        72        H
        0xBE,0x80,0xBE,0x55,0x55,0x55,0x55,        //        73        I
        0xDF,0xBF,0xBE,0xC0,0xFE,0x55,0x55,        //        74        J
        0x80,0xF7,0xEB,0xDD,0xBE,0x55,0x55,        //        75        K
        0x80,0xBF,0xBF,0xBF,0x55,0x55,0x55,        //        76        L
        0x80,0xFD,0xF3,0xFD,0x80,0x55,0x55,        //        77        M
        0x80,0xF9,0xF7,0xCF,0x80,0x55,0x55,        //        78        N
        0xC1,0xBE,0xBE,0xBE,0xC1,0x55,0x55,        //        79        O
        0x80,0xF6,0xF6,0xF6,0xF9,0x55,0x55,        //        80        P
        0xC1,0xBE,0xAE,0xDE,0xA1,0x55,0x55,        //        81        Q
        0x80,0xF6,0xE6,0xD6,0xB9,0x55,0x55,        //        82        R
        0xD9,0xB6,0xB6,0xB6,0xCD,0x55,0x55,        //        83        S
        0xFE,0xFE,0x80,0xFE,0xFE,0x55,0x55,        //        84        T
        0xC0,0xBF,0xBF,0xBF,0xC0,0x55,0x55,        //        85        U
        0xF0,0xCF,0xBF,0xCF,0xF0,0x55,0x55,        //        86        V
        0xF0,0xCF,0xBF,0xC7,0xBF,0xCF,0xF0,        //        87        dat
        0x9C,0xEB,0xF7,0xEB,0x9C,0x55,0x55,        //        88        X
        0xF8,0xF7,0x8F,0xF7,0xF8,0x55,0x55,        //        89        Y
        0x9E,0xAE,0xB6,0xBA,0xBC,0x55,0x55,        //        90        Z
        0x80,0xBE,0xBE,0x55,0x55,0x55,0x55,        //        91        [
        0xFC,0xFB,0xF7,0xEF,0x9F,0x55,0x55,        //        92        
        0xBE,0xBE,0x80,0x55,0x55,0x55,0x55,        //        93        ]
        0xF7,0xFB,0xFD,0xFB,0xF7,0x55,0x55,        //        94        ^
        0xBF,0xBF,0xBF,0xBF,0xBF,0x55,0x55,        //        95        _
        0xFC,0xFB,0xFF,0x55,0x55,0x55,0x55,        //        96        `
        0xDF,0xAB,0xAB,0x87,0x55,0x55,0x55,        //        97        a
        0x80,0xD7,0xBB,0xBB,0xC7,0x55,0x55,        //        98        b
        0xC7,0xBB,0xBB,0xD7,0x55,0x55,0x55,        //        99        c
        0xC7,0xBB,0xBB,0xD7,0x80,0x55,0x55,        //        100        d
        0xC7,0xAB,0xAB,0xB7,0x55,0x55,0x55,        //        101        e
        0xF7,0x81,0xF6,0xFD,0x55,0x55,0x55,        //        102        f
        0x67,0x5B,0x5B,0xA7,0x55,0x55,0x55,        //        103        g
        0x80,0xF7,0xFB,0xFB,0x87,0x55,0x55,        //        104        h
        0xC2,0xBF,0x55,0x55,0x55,0x55,0x55,        //        105        i
        0x7F,0x7B,0x82,0x55,0x55,0x55,0x55,        //        106        j
        0x80,0xEF,0xD7,0xBB,0x55,0x55,0x55,        //        107        k
        0xFE,0x80,0xFF,0x55,0x55,0x55,0x55,        //        108        l
        0x83,0xF7,0xFB,0x87,0xFB,0x87,0x55,        //        109        m
        0x83,0xF7,0xFB,0xFB,0x87,0x55,0x55,        //        110        n
        0xC7,0xBB,0xBB,0xC7,0x55,0x55,0x55,        //        111        o
        0x03,0xE7,0xDB,0xDB,0xE7,0x55,0x55,        //        112        p
        0xE7,0xDB,0xDB,0xE7,0x03,0x55,0x55,        //        113        q
        0x83,0xF7,0xFB,0xFB,0xF7,0x55,0x55,        //        114        r
        0xB7,0xAB,0xAB,0xDB,0x55,0x55,0x55,        //        115        s
        0xFB,0xC1,0xBB,0x55,0x55,0x55,0x55,        //        116        t
        0xC3,0xBF,0xBF,0xDF,0x83,0x55,0x55,        //        117        u
        0xE3,0xDF,0xBF,0xDF,0xE3,0x55,0x55,        //        118        v
        0xC3,0xBF,0xCF,0xBF,0xC3,0x55,0x55,        //        119        dat
        0xBB,0xD7,0xEF,0xD7,0xBB,0x55,0x55,        //        120        x
        0xE3,0x5F,0x5F,0x83,0x55,0x55,0x55,        //        121        y
        0x9B,0xAB,0xAB,0xB3,0x55,0x55,0x55,        //        122        z
        0xF7,0xC9,0xBE,0x55,0x55,0x55,0x55,        //        123        {
        0xFF,0x80,0xFF,0x55,0x55,0x55,0x55,        //        124        |
        0xBE,0xC9,0xF7,0x55,0x55,0x55,0x55,        //        125        }
        0xFF,0xFF,0x55,0x55,0x55,0x55,0x55,        //        126        ~
        0x01,0x7D,0x7D,0x7D,0x01,0x55,0x55,        //        127        
};


const far rom unsigned char Font18[12][16]={
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x55,0x55,0x55,0x55,  // .
0x00,0x80,0xF0,0xFC,0x3F,0x07,0x00,0x00,0x1C,0x1F,0x07,0x00,0x00,0x00,0x00,0x55,  // /
0xFC,0xFE,0x07,0x03,0x03,0x07,0xFE,0xFC,0x07,0x0F,0x1C,0x18,0x18,0x1C,0x0F,0x07,  // 0
0x00,0x30,0x38,0x1C,0x0E,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x1F,0x00,  // 1
0x0C,0x0E,0x07,0x83,0xC3,0xE7,0x7E,0x3C,0x1C,0x1E,0x1F,0x1B,0x19,0x18,0x18,0x18,  // 2
0x04,0x06,0x07,0x63,0x77,0xFF,0xDE,0x80,0x06,0x0E,0x1C,0x18,0x18,0x1C,0x0F,0x07,  // 3
0x80,0xE0,0xF0,0x7C,0x1E,0xFF,0xFF,0x00,0x03,0x03,0x03,0x03,0x03,0x1F,0x1F,0x03,  // 4
0x7F,0x7F,0x33,0x33,0x33,0x73,0xE3,0xC0,0x06,0x0E,0x1C,0x18,0x18,0x1C,0x0F,0x07,  // 5
0xFC,0xFE,0xC7,0x63,0x63,0xE3,0xC7,0x86,0x07,0x0F,0x1C,0x18,0x18,0x1C,0x0F,0x07,  // 6
0x03,0x03,0x03,0xE3,0xF3,0x7F,0x1F,0x07,0x00,0x00,0x00,0x1F,0x1F,0x00,0x00,0x00,  // 7
0x9C,0xFE,0xF7,0x63,0x63,0xF7,0xFE,0x9C,0x07,0x0F,0x1C,0x18,0x18,0x1C,0x0F,0x07,  // 8
0x3C,0x7E,0xE7,0xC3,0xC3,0xE7,0xFE,0xFC,0x0C,0x1C,0x18,0x18,0x18,0x1C,0x0F,0x07,  // 9

//0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,0x,  // 

};


// Rcupr :
const far rom unsigned char Font2[95][5]={
    0b00000000,        0b00000000,        0b00000000,        0b00000000,        0b00000000, //SPACE
    0b01000100,            0b01000100,        0b01000100,        0b00000000,        0b01000100, //!
    0b10101010,        0b10101010,        0b00000000,        0b00000000,        0b00000000, //"
    0b10101010,        0b11101110,        0b10101010,        0b11101110,        0b10101010, //#
    0b01100110,        0b11001100,        0b11001100,        0b01100110,        0b11101110, //$
    0b10101010,        0b00100010,        0b01000100,        0b10001000,        0b10101010, //%
    0b01000100,        0b10101010,        0b01000100,        0b10101010,        0b01100110, //&
    0b01000100,        0b01000100,        0b00000000,        0b00000000,        0b00000000, //'
    0b01000100,        0b10001000,        0b10001000,        0b10001000,        0b01000100, //(
    0b01000100,        0b00100010,        0b00100010,        0b00100010,        0b01000100, //)
    0b00000000,        0b10101010,        0b01000100,        0b10101010,        0b00000000, //*
    0b00000000,        0b01000100,        0b11101110,        0b01000100,        0b00000000, //+
    0b00000000,        0b00000000,        0b00000000,        0b01000100,        0b10001000, //,
    0b00000000,        0b00000000,        0b11101110,        0b00000000,        0b00000000, //-
    0b00000000,        0b00000000,        0b00000000,        0b00000000,        0b01000100, //.
    0b00100010,        0b00100010,        0b01000100,        0b10001000,        0b10001000, ///
    0b11101110,        0b10101010,        0b10101010,        0b10101010,        0b11101110, //0
        0b01000100,        0b11001100,        0b01000100,        0b01000100,        0b11101110, //1
        0b11101110,        0b00100010,        0b11101110,        0b10001000,        0b11101110, //2
        0b11101110,        0b00100010,        0b11101110,        0b00100010,        0b11101110, //3
        0b10101010,        0b10101010,        0b11101110,        0b00100010,        0b00100010, //4
        0b11101110,        0b10001000,        0b11101110,        0b00100010,        0b11101110, //5
        0b11001100,        0b10001000,        0b11101110,        0b10101010,        0b11101110, //6
        0b11101110,        0b00100010,        0b01000100,        0b10001000,        0b10001000, //7
        0b11101110,        0b10101010,        0b11101110,        0b10101010,        0b11101110, //8
        0b11101110,        0b10101010,        0b11101110,        0b00100010,        0b01100110, //9
        0b00000000,        0b01000100,        0b00000000,        0b01000100,        0b00000000, //:
        0b00000000,        0b01000100,        0b00000000,        0b01000100,        0b10001000, //;
        0b00100010,        0b01000100,        0b10001000,        0b01000100,        0b00100010, //<
        0b00000000,        0b11101110,        0b00000000,        0b11101110,        0b00000000, //=
        0b10001000,        0b01000100,        0b00100010,        0b01000100,        0b10001000, //>
        0b11001100,        0b00100010,        0b01100110,        0b00000000,        0b01000100, //?
        0b01000100,        0b10101010,        0b11101110,        0b10001000,        0b01100110, //@
        0b11101110,        0b10101010,        0b11101110,        0b10101010,        0b10101010, //A
        0b11001100,        0b10101010,        0b11101110,        0b10101010,        0b11001100, //B
        0b11101110,        0b10001000,        0b10001000,        0b10001000,        0b11101110, //C
        0b11001100,        0b10101010,        0b10101010,        0b10101010,        0b11001100, //D
        0b11101110,        0b10001000,        0b11101110,        0b10001000,        0b11101110, //E
        0b11101110,        0b10001000,        0b11101110,        0b10001000,        0b10001000, //F
        0b11101110,        0b10001000,        0b10001000,        0b10101010,        0b11101110, //G
        0b10101010,        0b10101010,        0b11101110,        0b10101010,        0b10101010, //H
        0b11101110,        0b01000100,        0b01000100,        0b01000100,        0b11101110, //I
        0b00100010,        0b00100010,        0b00100010,        0b10101010,        0b11101110, //J
        0b10001000,        0b10101010,        0b11001100,        0b11001100,        0b10101010, //K
        0b10001000,        0b10001000,        0b10001000,        0b10001000,        0b11101110, //L
        0b10101010,        0b11101110,        0b11101110,        0b10101010,        0b10101010, //M
        0b00000000,        0b11001100,        0b10101010,        0b10101010,        0b10101010, //N
        0b01000100,        0b10101010,        0b10101010,        0b10101010,        0b01000100, //O
        0b11101110,        0b10101010,        0b11101110,        0b10001000,        0b10001000, //P
        0b01000100,        0b10101010,        0b10101010,        0b11101110,        0b01100110, //Q
        0b11101110,        0b10101010,        0b11001100,        0b11101110,        0b10101010, //R
        0b11101110,        0b10001000,        0b11101110,        0b00100010,        0b11101110, //S
        0b11101110,        0b01000100,        0b01000100,        0b01000100,        0b01000100, //T
        0b10101010,        0b10101010,        0b10101010,        0b10101010,        0b11101110, //U
        0b10101010,        0b10101010,        0b10101010,        0b10101010,        0b01000100, //V
        0b10101010,        0b10101010,        0b11101110,        0b11101110,        0b10101010, //W
        0b00000000,        0b10101010,        0b01000100,        0b01000100,        0b10101010, //X
        0b10101010,        0b10101010,        0b01000100,        0b01000100,        0b01000100, //Y
        0b11101110,        0b00100010,        0b01000100,        0b10001000,        0b11101110, //Z
        0b11101110,        0b10001000,        0b10001000,        0b10001000,        0b11101110, //[
        0b10001000,        0b10001000,        0b01000100,        0b00100010,        0b00100010, //\
        0b11101110,        0b00100010,        0b00100010,        0b00100010,        0b11101110, //]
        0b01000100,        0b10101010,        0b00000000,        0b00000000,        0b00000000, //^
        0b00000000,        0b00000000,        0b00000000,        0b00000000,        0b11101110, //_
        0b00000000,        0b00000000,        0b00000000,        0b00000000,        0b11101110, //_
        0b10001000,        0b01000100,        0b00000000,        0b00000000,        0b00000000, //`
        0b00000000,                 0b01000100,                 0b10101010,                 0b10101010,         0b01100110, //a
        0b10001000, 0b11001100, 0b10101010, 0b10101010, 0b11001100, //b
        0b00000000,        0b01100110, 0b10001000, 0b10001000, 0b01100110, //c
        0b00100010,        0b01100110, 0b10101010, 0b10101010, 0b01100110, //d
        0b00000000, 0b01000100, 0b10101010, 0b11001100, 0b01100110, //e
        0b01100110,        0b01000100, 0b11101110, 0b01000100, 0b01000100, //f
        0b00000000, 0b01000100, 0b10101010, 0b01100110, 0b11001100, //g
        0b10001000, 0b11001100, 0b10101010, 0b10101010, 0b10101010, //h
        0b01000100,        0b00000000, 0b01000100, 0b01000100, 0b01000100, //i
        0b01000100, 0b00000000, 0b01000100, 0b01000100, 0b10001000, //j
        0b10001000,        0b10001000, 0b10101010, 0b11001100, 0b10101010, //k
        0b01000100,        0b01000100, 0b01000100, 0b01000100, 0b01000100, //l
        0b00000000,        0b11101110, 0b11101110, 0b10101010, 0b10101010, //m
        0b00000000,        0b11001100, 0b10101010, 0b10101010, 0b10101010, //n
        0b00000000,        0b01000100, 0b10101010, 0b10101010, 0b01000100, //o
        0b00000000,        0b11001100, 0b10101010, 0b11001100, 0b10001000, //p
        0b00000000,        0b01100110, 0b10101010, 0b01100110, 0b00100010, //q
        0b00000000,        0b10001000, 0b11101110, 0b10001000, 0b10001000, //r
        0b00000000, 0b01100110, 0b11001100, 0b00100010, 0b11001100, //s
        0b01000100,        0b11101110, 0b01000100, 0b01000100, 0b01000100, //t
        0b00000000, 0b10101010, 0b10101010, 0b10101010, 0b01000100, //u
        0b00000000, 0b10101010, 0b10101010, 0b01000100, 0b01000100, //v
        0b00000000,        0b10101010, 0b10101010, 0b11101110, 0b10101010, //w
        0b00000000,        0b10101010, 0b01000100, 0b01000100, 0b10101010, //x
        0b00000000,        0b10101010, 0b10101010, 0b01100110, 0b11001100, //y
        0b00000000, 0b11101110, 0b01100110, 0b11001100, 0b11101110, //z
        0b00100010,        0b01000100,        0b11001100,        0b01000100,        0b00100010, //{
        0b01000100,        0b01000100,        0b01000100,        0b01000100,        0b01000100, //|
        0b10001000,        0b01000100,        0b01100110,        0b01000100,        0b10001000, //}
        0b00000000,        0b11001100,        0b10101010,        0b00000000,        0b00000000  //~
};