
#include <p18cxxx.h>	      /* C18 compiler processor defs */

//*****************************************************************************
//* Afficheur GLCD 128 x 64 *
//*****************************************************************************
// LCD Module features and configuration

// initial state at the application startup :
#define GLCD_Data   		(PORTB)
#define b_GLCD_GCS2 		(LATAbits.LATA1)  
#define b_GLCD_GCS1 		(LATAbits.LATA0)   
#define b_GLCD_RS   		(LATAbits.LATA2)   
#define b_GLCD_RW   		(LATAbits.LATA3)  
#define b_GLCD_E    		(LATAbits.LATA5)  
#define b_GLCD_On   		(LATAbits.LATA4) 	// not available on my GLCD
#define b_GLCD_BL   		(LATAbits.LATA7) 

// Define the direction for each Input/Output pin (0-Output, 1-Input) :
#define TRIS_Data    		(LATB)
#define b_TRIS_GCS2  		(TRISAbits.TRISA1) 
#define b_TRIS_GCS1  		(TRISAbits.TRISA0)
#define b_TRIS_RS    		(TRISAbits.TRISA2) 
#define b_TRIS_RW    		(TRISAbits.TRISA3) 
#define b_TRIS_E     		(TRISAbits.TRISA5) 
#define b_TRIS_On    		(TRISAbits.TRISA4) 	// not available on my GLCD
#define b_TRIS_BL    		(TRISAbits.TRISA7)

void Delay(void);
unsigned char GLCD_Read(void);
void Wait_Not_Busy(void);
void GLCD_Write_Cmd(unsigned char data);
void GLCD_Write_Data (unsigned char data);
void ClearScreen(void);
void Init_GLCD(void);
void PutChar(unsigned char data);
unsigned char GLCD_Read_Data(void);
void SetPos(unsigned char x,unsigned char y);
void WritePosition(void);
void plot(unsigned char x,unsigned char y);
void hline(unsigned char x1,unsigned char x2,unsigned char y);
void vline(unsigned char x,unsigned char y1,unsigned char y2);
void box(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2);
void FilledBox(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2);
void circle(int xc,int yc,int r);
void PutMessage( char rom *Message);
void PutLogo( char far rom *logo);
void FillWhiteZone(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2);
void FillBlackZone(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2);
void unplot(unsigned char x,unsigned char y);
void displayNum(int x, int y, short int theValue);
void PutSmallChar(unsigned char data);
void displaySmallNum(int x, int y, short int INTValue);
void PutFloat(char* floatdata);
void PutHChar(unsigned char data);
void MoveDown(void);
void PutHFloat(char* floatdata);
void MoveRightH(void);
void displayHNum(int x, int y, short int INTValue);
void PutBars(unsigned char x,unsigned char y,unsigned char Percent);

