//	TEST for GLCD UNICORN LIBRARY

/****************CONFIGURATION BITS ************************/
#pragma config OSC = HS			// OSCILLATOR
#pragma config FCMEN = OFF		// Fail Safe Clock Monitor
#pragma config IESO = OFF 		// Internal External Osc. Switch Disabled
#pragma config PWRT = OFF		// Power Up Timer Disabled
#pragma config WDT = OFF		// WATCHDOG Enabled
#pragma config MCLRE = ON		// MCLR Pin Enable
#pragma config DEBUG = OFF		// DEBUG Disabled


/************************ INCLUDE ***************************/
#include <p18cxxx.h>	       			/* C18 compiler processor defs */
#include "h/delay.h"					/* Defs DELAY functions */
#include "h/GLCD.h"						/* Gestion GLCD */
#include "h/ftoa.h"						/* Adapt Chaine de caractre */

/******************  VARIABLES ******************************/
char DATAtoLCD[30];
const far rom unsigned char FUTURA_SCIENCES[];
float FLOAT_var = 12.56;
short int Year = 2010;
int p;
/************************************************************/

void main(void)
{

// A/D PORT Configuration
 ADCON1 = 0x00;			// all digital
 INTCON2bits.RBPU = 1;  // Disable internal PORTB pull-ups

//// I/O Configuration
TRISA = 0x00;		// 0UPUTS
TRISB = 0x00;		// 0UPUTS
TRISC = 0x00;		// 0UPUTS
LATC = 0x00;		// Set unsed outputs

Init_GLCD(); 		// Initialisation de l'afficheur
DELAY_MS(100);


 while(1)
  {

//				SetPos(0,0);								// Positionner le curseur
//				PutLogo((rom far char*)FUTURA_SCIENCES);	// Afficher une image (logiciel BitMapToLCD pour la conversion)
				
//				box(0,0,127,63);							// Raliser un rectangle


				hline(0,128,20) ;							// Raliser une ligne horizontale   ( dbut ligne X, fin de ligne X, cartement depuis le haut de l'ecran )
				hline(20,108,25) ;							// Raliser une ligne horizontale   ( dbut ligne X, fin de ligne X, cartement depuis le haut de l'ecran )

				vline (62,30,60);							// Raliser une ligne verticale 	( cartement depuis bord gauche, debut ligne Y , fin ligne Y )
				vline (12,30,60);							// Raliser une ligne verticale 	( cartement depuis bord gauche, debut ligne Y , fin ligne Y )
				vline (116,30,60);							// Raliser une ligne verticale 	( cartement depuis bord gauche, debut ligne Y , fin ligne Y )


//				circle (80,44,5);							// Raliser un cercle
//				hline(48,112,39) ;							// Raliser une ligne horizontale
//
//				FillBlackZone (102,30,110,38);				// Raliser une zone noire
//
//				FillBlackZone (57,25,60,30);				// Raliser une zone noire
//				hline(54,64,31) ;							// Raliser une ligne horizontale
//				hline(55,63,32) ;							// Raliser une ligne horizontale
//				hline(56,62,33) ;							// Raliser une ligne horizontale
//				hline(57,61,34) ;							// Raliser une ligne horizontale
//				hline(58,60,35) ;							// Raliser une ligne horizontale
//				plot(59,31) ;								// Raliser un point
//
//				box(0,20,127,55);							// Raliser un rectangle
//				box(60,10,68,18);							// Raliser un rectangle
//				box(38,7,46,15);							// Raliser un rectangle
//
//				Bars demo :
//		        for(p=0;p<11;p++){
//		            PutBars(108,40,(p*10));
//		            DELAY_MS(30);
//		        }
//		
//		        for(p=11;p>0;p--){
//		            PutBars(108,40,((p-1)*10));
//		            DELAY_MS(30);
//		        }

				SetPos(10,0);								// Positionner le curseur (x,y)
				PutMessage((rom char*)"Graphic");			// Ecrire un message
				//PutMessage((rom char*)"\x16\x38\x18Demo");	// ascii 22 (0x16) is set position followed by x,y
//
				displaySmallNum (20,15,Year);				// Ecrire un INT en "petit"  (-> Seulement les chiffres, les lettres sont a crer)
//				displayNum (10,80,Year);					// Ecrire un INT en "normal" (-> Chiffres + Lettres )
				displayHNum (60,0,Year);					// Ecrire un INT en "gros"  (-> Seulement les chiffres, les lettres sont a crer)
//		
//				SetPos(10,40);								// Positionner le curseur
//				ftoa (FLOAT_var,DATAtoLCD,2);				// Convertir un float en une chaine de caractres
//				
//				SetPos(10,48);								// Positionner le curseur
//				PutFloat (DATAtoLCD);						// Afficher le float (taille normale)
//				SetPos(50,48);								// Positionner le curseur
//				PutHFloat (DATAtoLCD);						// Afficher le float en gros
		               

  }  	  // end WHILE(1)

} 		  // end MAIN()


const far rom unsigned char FUTURA_SCIENCES[]={
 128 /*width */,
 64 /* height */,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x40 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x40 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x20 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x30 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x30 , 0x00 , 0x00 , 0x00 , 0x00 , 0xF0 , 0x3F,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x18 , 0x7C , 0x00 , 0x00 , 0x00 , 0xF8 , 0x1F,
 0x00 , 0x38 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x18 , 0xFE , 0x01 , 0x00 , 0x00 , 0x38 , 0x00,
 0x00 , 0x38 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x1C , 0xFF , 0x07 , 0x00 , 0x00 , 0x38 , 0x00,
 0x00 , 0x38 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x8C , 0xFF , 0x0F , 0x00 , 0x00 , 0x1C , 0xE0,
 0x38 , 0xFE , 0x8E , 0xE3 , 0xEC , 0x0F , 0x00 , 0x00,
 0x00 , 0x8E , 0xFF , 0x3F , 0x00 , 0x00 , 0xFC , 0xEF,
 0x38 , 0xFE , 0x8E , 0xE3 , 0xEF , 0x0F , 0x00 , 0x00,
 0x00 , 0x8F , 0xFF , 0x7F , 0x00 , 0x00 , 0xFC , 0xEF,
 0x38 , 0x1C , 0x8E , 0xE3 , 0x2F , 0x0E , 0x00 , 0x00,
 0x00 , 0x8F , 0xFF , 0xFF , 0x00 , 0x00 , 0x0E , 0x70,
 0x1C , 0x0E , 0xC7 , 0x71 , 0x00 , 0x0E , 0x00 , 0x00,
 0x80 , 0x87 , 0xFF , 0xFF , 0x01 , 0x00 , 0x0E , 0x70,
 0x1C , 0x0E , 0xC7 , 0x71 , 0xE0 , 0x0F , 0x00 , 0x00,
 0x80 , 0x87 , 0xFF , 0xFF , 0x01 , 0x00 , 0x0E , 0x70,
 0x1C , 0x0E , 0xC7 , 0x71 , 0xF8 , 0x0F , 0x00 , 0x00,
 0x80 , 0x87 , 0xFF , 0xFF , 0x03 , 0x00 , 0x07 , 0x38,
 0x0E , 0x87 , 0xE3 , 0x38 , 0x1C , 0x07 , 0x00 , 0x00,
 0xC0 , 0x87 , 0xFF , 0xFF , 0x07 , 0x00 , 0x07 , 0xF8,
 0x0F , 0x87 , 0xFF , 0x38 , 0x1C , 0x07 , 0x00 , 0x00,
 0xC0 , 0x87 , 0xFF , 0xFF , 0x07 , 0x00 , 0x07 , 0xF8,
 0x0F , 0xBF , 0xFF , 0x38 , 0xFC , 0x07 , 0x00 , 0x00,
 0xE0 , 0x87 , 0xFF , 0xFF , 0x0F , 0x80 , 0x03 , 0x78,
 0x07 , 0x9F , 0x77 , 0x1C , 0xBC , 0x03 , 0x00 , 0x00,
 0xE0 , 0x87 , 0xFF , 0xFF , 0x0F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF0 , 0x87 , 0xFF , 0xFF , 0x1F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF0 , 0x87 , 0xFF , 0xFF , 0x1F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF0 , 0x87 , 0xFF , 0xFF , 0x3F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF8 , 0x87 , 0x1F , 0xF0 , 0x3F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF8 , 0x87 , 0x0F , 0xE0 , 0x7F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF8 , 0x8F , 0x07 , 0xC0 , 0x7F , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF8 , 0x8F , 0x03 , 0x80 , 0x7F , 0x00 , 0xF8 , 0x01,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xF8 , 0x1F , 0x01 , 0x00 , 0xFF , 0x00 , 0xFE , 0x01,
 0xC0 , 0x01 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xFC , 0x3F , 0x00 , 0x00 , 0xFE , 0x00 , 0x87 , 0x01,
 0xC0 , 0x01 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xFC , 0x7F , 0x00 , 0x00 , 0xFC , 0x00 , 0x07 , 0x01,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xFC , 0xFF , 0x00 , 0x00 , 0xFC , 0x81 , 0x03 , 0xE0,
 0xE3 , 0xE0 , 0xC3 , 0x3D , 0xF0 , 0xC1 , 0x07 , 0x3F,
 0xFC , 0xFF , 0x03 , 0x00 , 0xF8 , 0x81 , 0x1F , 0xF8,
 0xE7 , 0xF8 , 0xC7 , 0x3F , 0xFC , 0xF3 , 0x8F , 0x7F,
 0xFC , 0xFF , 0x7F , 0x1C , 0xF0 , 0x81 , 0x7F , 0x3C,
 0xE6 , 0x1C , 0xC7 , 0x3F , 0x1E , 0x3B , 0xCE , 0x61,
 0xFC , 0xFF , 0xFF , 0x0F , 0xE0 , 0x03 , 0xFF , 0x0E,
 0x72 , 0x0E , 0xE7 , 0x38 , 0x07 , 0x1D , 0xEE , 0x01,
 0xFC , 0xFF , 0xFF , 0x07 , 0xE0 , 0x03 , 0xFC , 0x0E,
 0x70 , 0xFE , 0xE7 , 0x38 , 0x07 , 0xFC , 0xEF , 0x0F,
 0xF8 , 0xFF , 0xFF , 0x03 , 0xC0 , 0x03 , 0xF0 , 0x0E,
 0x70 , 0xFE , 0xE7 , 0x38 , 0x07 , 0xFC , 0xCF , 0x1F,
 0xF8 , 0xFF , 0xFF , 0x00 , 0x80 , 0x27 , 0x70 , 0x07,
 0x39 , 0x07 , 0x70 , 0x9C , 0x83 , 0x0E , 0x00 , 0x1C,
 0xF8 , 0xFF , 0x3F , 0x00 , 0x80 , 0x67 , 0x38 , 0x8F,
 0x39 , 0x0F , 0x72 , 0x9C , 0xC7 , 0x1E , 0x14 , 0x1C,
 0xF0 , 0xFF , 0x0F , 0x00 , 0x00 , 0xE7 , 0x1F , 0xFE,
 0x39 , 0xFE , 0x73 , 0x1C , 0xFF , 0xFC , 0xF7 , 0x0F,
 0xE0 , 0xFF , 0x03 , 0x00 , 0x00 , 0xE6 , 0x07 , 0x7C,
 0x1C , 0xFC , 0x39 , 0x0E , 0x3E , 0xF8 , 0xF3 , 0x03,
 0xE0 , 0x7F , 0x00 , 0x00 , 0x00 , 0x0E , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x80 , 0x0F , 0x00 , 0x00 , 0x00 , 0x0C , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x08 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x08 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x10 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x10 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x06 , 0x00 , 0x00 , 0x00 , 0x06 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x01 , 0x00 , 0x00 , 0x00 , 0x01 , 0x04 , 0x00 , 0x00,
 0x00 , 0x10 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x01 , 0x00 , 0x00 , 0x00 , 0x01 , 0x04 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0xE7 , 0x54 , 0x74 , 0x03 , 0x17 , 0x5D , 0x54 , 0x0E,
 0x38 , 0x97 , 0xF3 , 0x38 , 0xC7 , 0x81 , 0x73 , 0x6E,
 0x11 , 0x4D , 0x94 , 0x04 , 0x11 , 0x45 , 0x34 , 0x10,
 0x84 , 0x50 , 0x14 , 0x85 , 0x28 , 0x40 , 0x88 , 0x92,
 0x11 , 0x45 , 0x94 , 0x04 , 0x11 , 0x45 , 0x14 , 0xDE,
 0x8D , 0xD0 , 0x17 , 0x85 , 0x6F , 0x40 , 0x88 , 0x92,
 0x11 , 0x45 , 0x94 , 0x04 , 0x11 , 0x45 , 0x14 , 0x11,
 0xB0 , 0x50 , 0x10 , 0x85 , 0x80 , 0x41 , 0x88 , 0x92,
 0x11 , 0x45 , 0x94 , 0x24 , 0x11 , 0x45 , 0x14 , 0x11,
 0xA0 , 0x50 , 0x14 , 0x85 , 0x08 , 0x49 , 0x88 , 0x92,
 0xE1 , 0x84 , 0x97 , 0x24 , 0xE1 , 0x99 , 0x17 , 0x1E,
 0x1C , 0x97 , 0x13 , 0x39 , 0xE7 , 0x88 , 0x73 , 0x92,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00,
 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00 , 0x00
};


